// wormUnique_PeasyCam5
// 16 11 2014
// Modif de http://www.openprocessing.org/sketch/77718
// "Worm" de Adam Lastowka
// en remplacant Maker[] Worm = new Maker[1];
// par             Maker Worm = new Maker();
// 1 seul worm
// + peasycam by Jonathan Feinberg

/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/77718*@* */
/* !do not delete the line above, required for linking your tweak if you upload again */
// A worm, building a landscape by "tunneling" all over it, raising and lowering the terrain.
// Press any key to skip forwards 500 iterations.
// Somewhat like the sandworms in "Dune" by Frank Herbert,
// except for the rainbows and strange fading trails.

// Attention Download sketch/77718 donne sketch77718.zip qui donne sketch_121101a

// Utilise la "contributed library" peasycam by Jonathan Feinberg
// http://mrfeinberg.com/peasycam/
//
// PeasyCam: Souris Molette           : Zoom
//           Souris Clic droit + Drag : Zoom      
//           Souris Clic + Drag       : Rotation      
//           Souris 2 x Clic          : Reset position
//           Souris cmd + Clic + Drag : Translate (MacOS)

import peasy.*;

PeasyCam pcam;
float[][] hm = new float[256][256];
float[][] hm2 = new float[256][256];

Maker Worm = new Maker(); 
// float M = 6;              // M = diametre du worm
float M = 3;              // M = diametre du worm
float wormTemp;
int x, y, Alea;
float Distance;

PImage Image1;

void setup() {
  size(800, 600, P3D);
  // size(400, 300, P3D);

  Image1 = loadImage("Reunion256x256.png");
  // background(Image1);

  //  pcam = new PeasyCam(this, 100);

  pcam = new PeasyCam(this, width/2, height/2, 0, 200); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
  pcam.setMinimumDistance(50);
  pcam.setMaximumDistance(1000);

  Worm = new Maker();

  noStroke();
  generateLandscape();

  // colorMode(HSB);
  colorMode(RGB);
  // frameRate(2); // A mettre pour mieux comprendre

  println("hm.length = " + hm.length);
}

void draw() {
  background(0, 0, 0);
  // background(0);
  // image(Image1, 0, 0);

  lights();

  // scale(zoom);
  // translate(width/2/zoom, height/2/zoom);
  translate(width/2, height/2);
  //   rotateY(map(mouseX, 0, width, -PI, PI));
  //  rotateX(PI/6);
  // rotateY(map(mouseX/2,0,width,-PI,PI));
  // rotateX(map(mouseY/2,0,height,-PI,PI));
  // println("Worm.wormTheta = " + Worm.wormTheta + "  Worm.wormThetaDelta = " + Worm.wormThetaDelta);
  paintLandscape();
  // temGen();
}

void keyPressed() {
  // generateLandscape();
  // temGen();
  // Lissage();

  if (key == ' ') {         // barre d'espace
    temGen();
  }
  else  if ( key == 'l' || key == 'L' ) {
    Lissage();
  }
}

void generateLandscape() {
  Image1.loadPixels();

  for ( x = 0; x < hm.length; x++) {
    for ( y = 0; y < hm.length; y++) {
      // hm[x][y] = 0;
      // hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 255.f;
      // hm[x][y] = brightness(Image1.pixels[x*4 + (y*4*3 * hm.length)])/ 25.f;
      hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 8.f;
      // println(brightness(Image1.pixels[x*4 + (y*4*3 * hm.length)])/ 25.f);
      // if (x == 128) {
      // println("generateLandscape  hm[128]["  + y + "] = " + hm[128][y] + "  Distance = " + Distance);
      // }
    }
  }
  // for (int i = 0; i < 600; i++) temGen();
}

void temGen() {
  // wormTemp = 0;
  // wormTemp = Worm.wormTheta;
  // Worm.wormTheta = (wormTemp+Worm.wormTheta*2)/3;
  //  Worm.x += sin(Worm.wormTheta)*10;
  //  Worm.y += cos(Worm.wormTheta)*10;
  Worm.x += sin(Worm.wormTheta)*2;
  Worm.y += cos(Worm.wormTheta)*2;
  Worm.wormTheta += Worm.wormThetaDelta;
  Worm.wormThetaDelta += random(-0.1, 0.1);
  // Worm.wormThetaDelta /= 1.05; 
  Worm.wormThetaDelta /= 1.20; // 1.05 le worm tourne beaucoup 1.25 tourne peu
  //  if (Worm.x > hm.length/2)  Worm.x=-hm.length/2;
  //  if (Worm.x < -hm.length/2) Worm.x=hm.length/2;
  //  if (Worm.y > hm.length/2)  Worm.y=-hm.length/2;
  //  if (Worm.y < -hm.length/2) Worm.y=hm.length/2;
  if (Worm.x > hm.length/4)  Worm.x=-hm.length/4;
  if (Worm.x < -hm.length/4) Worm.x=hm.length/4;
  if (Worm.y > hm.length/4)  Worm.y=-hm.length/4;
  if (Worm.y < -hm.length/4) Worm.y=hm.length/4;
  Alea = int(random(hm.length));
  for ( x = 0; x < hm.length; x++) {
    for ( y = 0; y < hm.length; y++) {
      Distance = dist((x-hm.length/2)/M, (y-hm.length/2)/M, Worm.x/M, Worm.y/M);
      // if (Distance != 0) hm[x][y] = hm[x][y] + sin(TWO_PI / (Distance * Distance)) * 4.5 * sin(Worm.wormTheta);
      // if (Distance != 0) hm[x][y] = hm[x][y] + (sin(TWO_PI / (Distance * Distance)) + 0) * 4.5 * (sin(Worm.wormTheta) + 0.5); // +1 pour que le worm soit toujours a la surface
      // if (Distance != 0) hm[x][y] = hm[x][y] + (sin(TWO_PI / (Distance * Distance)) + 0) * 4.5 ; // +1 pour que le worm soit toujours a la surface
      // if (Distance != 0) hm[x][y] = hm[x][y] + min((1 / (Distance * Distance)), 10) ; // +1 pour que le worm soit toujours a la surface
      if (Distance != 0) hm[x][y] = hm[x][y] - min((1 / (Distance)), 15) ; // 
//      if (Distance != 0) {
//        hm[x][y] = hm[x][y] - min((1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
//        if (x > 1)           hm[x-1][y] = hm[x-1][y] - min((0.1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
//        if (x < hm.length-1) hm[x+1][y] = hm[x+1][y] - min((0.1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
//        if (y > 1)           hm[x][y-1] = hm[x][y-1] - min((0.1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
//        if (y < hm.length-1) hm[x][y+1] = hm[x][y+1] - min((0.1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
//      }
      // if (x == 128) hm[x][y] = 0; // Creuse ligne verticale
      // if (y == 138) hm[x][y] = max( hm[x][y] - 5, 0); // Creuse ligne horizontale

      //      if (y == Alea-1) hm[x][y] = max( hm[x][y] - 5, 0); // Creuse ligne horizontale
      //      if (y == Alea) hm[x][y] = max( hm[x][y] + 5, 0); // Creuse ligne horizontale
      //      if (y == Alea+1) hm[x][y] = max( hm[x][y] - 5, 0); // Creuse ligne horizontale

      // if (x == 128) println("hm[128]["  + y + "] = " + hm[128][y] + "  Distance = " + Distance);
    }
  }
  Lissage();
}

void paintLandscape() {
  // stroke(128);
  // noStroke();
  // fill(0,0,255); 

  for ( x = 3; x < hm.length-5; x++) {
    for ( y = 3; y < hm.length-5; y++) {
      // fill(abs(4*hm[x][y]), 255, 255);//origin
      fill(Image1.pixels[x + (y * hm.length)]);
      beginShape(QUADS);
      vertex(x-hm.length/2, y-hm.length/2, hm[x][y]);
      vertex(x+1-hm.length/2, y-hm.length/2, hm[x+1][y]);
      vertex(x+1-hm.length/2, y+1-hm.length/2, hm[x+1][y+1]);
      vertex(x-hm.length/2, y+1-hm.length/2, hm[x][y+1]);
      endShape(CLOSE);
    }
  }
}


void Lissage() {
  //  for ( x = 1; x < hm.length-1; x++) {
  //    for ( y = 1; y < hm.length-1; y++) {
  //      hm[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;
  //    }
  //  }

  //    for(float x = 1; x < hm.length-1; x++) {
  //        for(float y = 1; y < hm.length-1; y++) {
  //          hm[(int)x][(int)y] = (hm[(int)x][(int)y]*2 + hm[(int)x+1][(int)y] + hm[(int)x-1][(int)y] + hm[(int)x][(int)y+1] + hm[(int)x][(int)y-1])/6;
  //        }
  //    }

  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;
    }
  }
  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      hm[x][y] = hm2[x][y];
    }
  }
  println("Lissage");
}


class Maker {
  float x;
  float y;
  float wormTheta;
  float wormThetaDelta;
}

